<template>
  <div class="app-container">
    <el-row :gutter="20">
      <!--用户数据-->
      <el-col :span="24" :xs="24">
        <el-form :model="queryParams" ref="queryForm" size="small" :inline="true" v-show="showSearch" label-width="68px">
          <el-form-item label="点位名称" prop="name">
            <el-input
              v-model="queryParams.name"
              placeholder="请输入点位名称"
              clearable
              style="width: 240px"
              @keyup.enter.native="handleQuery"
            />
          </el-form-item>
          <el-form-item>
            <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
            <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
          </el-form-item>
        </el-form>

        <el-row :gutter="10" class="mb8">
          <el-col :span="1.5">
            <el-button
              type="primary"
              plain
              icon="el-icon-plus"
              size="mini"
              @click="handleAdd"
              v-hasPermi="configPermi.add"
            >添加点位</el-button>
            <el-button
              type="primary"
              plain
              icon="el-icon-plus"
              size="mini"
              @click="handleAddImage"
              v-hasPermi="configPermi.add"
            >手绘图设置</el-button>
          </el-col>
          <right-toolbar :showSearch.sync="showSearch" @queryTable="getList" :columns="columns"></right-toolbar>
        </el-row>

        <el-table v-loading="loading" :data="tableList" @selection-change="handleSelectionChange">
          <el-table-column type="index" label="序号" align="center"  />
          <el-table-column label="点位名称" align="center" key="name" prop="name" v-if="columns[0].visible">
              <template slot-scope="scope">
              <el-tooltip class="item" effect="dark" :content="scope.row.name" placement="top">
                <div style="width: 100%;white-space: nowrap;overflow: hidden;text-overflow: ellipsis;">
                  <span style="width: 100%;white-space: nowrap;overflow: hidden;text-overflow: ellipsis;">{{ scope.row.name }}</span>
                </div>
              </el-tooltip>
            </template>
          </el-table-column>
          <el-table-column label="类型" align="center" key="typeName" prop="typeName" v-if="columns[1].visible" :show-overflow-tooltip="true" />
          <el-table-column label="可用状态" align="center" key="status" v-if="columns[2].visible">
            <template slot-scope="scope">
              <switchBox 
              :defaultChecked="true" 
              v-model="scope.row.status" 
              @changeFun="openAttraction(scope.row)" 
              :disabled="false"
              :active-value="1"
              :inactive-value="0"
               />
            </template>
          </el-table-column>
          <el-table-column label="创建时间" align="center" key="createTime" prop="createTime" v-if="columns[3].visible" />
          <el-table-column
            label="操作"
            align="center"
            width="160"
            class-name="small-padding fixed-width"
          >
            <template slot-scope="scope" v-if="scope.row.id !== 1">
              <el-button
                v-if="false"
                size="mini"
                type="text"
                icon="el-icon-document"
                @click="handleDetails(scope.row)"
                v-hasPermi="configPermi.details"
              >详情</el-button>
              <el-button
                size="mini"
                type="text"
                icon="el-icon-edit"
                @click="handleUpdate(scope.row)"
                v-hasPermi="configPermi.edit"
              >修改</el-button>
              <el-button
                size="mini"
                type="text"
                icon="el-icon-delete"
                @click="handleDelete(scope.row)"
                v-hasPermi="configPermi.delect"
              >删除</el-button>
            </template>
          </el-table-column>
        </el-table>

        <pagination
          v-show="total>0"
          :total="total"
          :page.sync="queryParams.pageNum"
          :limit.sync="queryParams.pageSize"
          @pagination="getList"
        />
      </el-col>
    </el-row>
    <!--  新增或修改  -->
    <addAndEdit ref="addAndEdit" @refresh="getList" />
    <!--  景区导览图 -->
    <scenicGuideImageForm ref="scenicGuideImageForm" />
  </div>
</template>

<script>
import { 
  listTableApi, 
  delTableParamsApi, 
  addTableApi
} from "@/api/CURD";
import addAndEdit from "./formBox/scenicGuideForm.vue"
import scenicGuideImageForm from "./formBox/scenicGuideImageForm.vue"
export default {
  name: "User",
  dicts: [],
  components: {addAndEdit,scenicGuideImageForm},
  data() {
    return {
      title: "景区导览",// 通用标题
      configPermi: {
        add: ['system:user:edit'], // 新增权限
        details: ['system:user:details'], // 详情权限
        delect: ['system:user:remove'], // 删除权限
        edit: ['system:user:edit'], // 编辑权限
        upload: ['system:user:upload'],// 导入权限
        export: ['system:user:export'],// 导出权限
      },
      configUrl: {
        list: '/merchant/merchantMapMark/pageList', // 列表地址
        delect: '/merchant/merchantMapMark/deleteById', // 删除地址
        upload: '',// 导入地址
        download:'', // 下载模板地址
        export: '',// 导出地址
        edit: '/merchant/merchantMapMark/insertOrUpdate', // 编辑地址
      },
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 用户表格数据
      tableList: null,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
      },
      dateRange: [],
      // 控制列表是否显示
      columns: [
        { key: 0, label: `景点名称`, visible: true },
        // { key: 1, label: `归属景区`, visible: true },
        { key: 2, label: `开/闭园时间`, visible: true },
        { key: 3, label: `开放状态`, visible: true },
        { key: 4, label: `景点产品`, visible: true },
      ],
    };
  },
  created() {
    this.getList();
  },
  methods: {
    /** 查询用户列表 */
    getList() {
      this.loading = true;
      listTableApi(
        this.configUrl.list,
        this.addDateRange(
          this.queryParams, 
          this.dateRange)).then(response => {
            this.tableList = response.data.rows;
            this.total = response.data.total;
            this.loading = false;
        }
      ).catch (error=>{
        console.error('获取列表失败!!!!',error)
        this.tableList = [];
        this.total = 0;
        this.loading = false
      }) 
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.dateRange = [];
      this.queryParams = {
        pageNum: 1,
        pageSize: 10,
      }
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.id);
      this.single = selection.length != 1;
      this.multiple = !selection.length;
    },
    /** 新增按钮操作 */
    handleAddImage() {
      if(this.$refs.scenicGuideImageForm) {
        this.$refs.scenicGuideImageForm.initData(this.title + '手绘图', "EDITInit",{})
      }
    },
    /** 新增按钮操作 */
    handleAdd() {
      if(this.$refs.addAndEdit) {
        this.$refs.addAndEdit.initData(this.title + '新增', "ADD",{})
      }
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      if(this.$refs.addAndEdit) {
        this.$refs.addAndEdit.initData(this.title + '编辑', "EDIT",{...row})
      }
    },
    handleDetails(row){
      if(this.$refs.detailsBox) {
        this.$refs.detailsBox.initData(this.title + '详情',"DEATILSInit", row)
      }
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids;
      this.$modal.confirm('是否确认删除编号为"' + ids + '"的数据项？').then( () => {
        return delTableParamsApi(this.configUrl.delect,{
          id: ids
        });
      }).then(() => {
        this.getList();
        this.$modal.msgSuccess("删除成功");
      }).catch((e) => {
        console.error("删除失败====",e)
      });
    },
    /** 导出按钮操作 */
    handleExport() {
      this.download(this.configUrl.export, {
        ...this.queryParams
      }, `${this.title }_${new Date().getTime()}.xlsx`)
    },
    /** 导入按钮操作 */
    handleImport() {
      if(this.$refs.upload) {
        this.$refs.upload.initData({
          width: '400px',
          // 弹出层标题（用户导入）
          title: this.title + "导入",
          // 下载模板地址
          importTemplate: this.configUrl.download,
          // 上传的地址
          url: this.configUrl.upload
        })
      }
    },
    /** 开/闭 园 */
    openAttraction(row) {
      console.log("row======",row)
      this.$modal.confirm(`是否确认${row.status == 0 ? '启用' : '禁用'} ${row.name}园区吗？`).then( () => {
        return addTableApi(this.configUrl.edit,{
          ...row,
          status: row.status == 0 ? 1 : 0
        });
      }).then(() => {
        this.getList();
        this.$modal.msgSuccess(`${row.status == 0 ? '启用' : '禁用'}成功`);
      }).catch((e) => {
        console.error("失败====",e)
      });
    },
  }
};
</script>
